Package: cookie
Title: HTTP Cookies Parser Middleware
Version: 1.0.0
Authors@R: c(
    person("Julio", "Collazos", , "amarullazo626@gmail.com", role = c("aut", "cre"), comment = c(ORCID = "0009-0006-5503-0997")),
    person(, "cookie contributors", role = c("ctb", "cph"),
           comment = "cookie contributors; authors listed in <https://github.com/jshttp/cookie/graphs/contributors>"),
    person(, "cookie-parser contributors", role = c("ctb", "cph"),
           comment = "cookie-parser contributors; authors listed in <https://github.com/expressjs/cookie-parser/graphs/contributors>"),
    person(, "cookie-signature contributors", role = c("ctb", "cph"),
           comment = "cookie-signature contributors; authors listed in <https://github.com/tj/node-cookie-signature/graphs/contributors>"),
    person(, "httpuv authors", role = c("ctb", "cph"),
           comment = "Development of the http_date_string function")
  )
Description: A cookie is a piece of data sent from a web server to a web client which helps
    in overcoming the statelessness constraint of the HTTP protocol. This package provides the tools
    to work with them in the form of a cookie parser middleware function, meant to be attached to
    a bigger R web application, and utilities to write, sign and unsign a cookie. For more details
    see the Mozilla Developer Network (MDN) web documentation in <https://developer.mozilla.org/en-US/docs/Web/HTTP/Guides/Cookies>.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: secretbase, utils
Suggests: curl, httpuv, later, R6, routing, testthat (>= 3.0.0),
        yyjsonr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-06-06 04:44:40 UTC; julio
Author: Julio Collazos [aut, cre] (ORCID:
    <https://orcid.org/0009-0006-5503-0997>),
  cookie contributors [ctb, cph] (cookie contributors; authors listed in
    <https://github.com/jshttp/cookie/graphs/contributors>),
  cookie-parser contributors [ctb, cph] (cookie-parser contributors;
    authors listed in
    <https://github.com/expressjs/cookie-parser/graphs/contributors>),
  cookie-signature contributors [ctb, cph] (cookie-signature
    contributors; authors listed in
    <https://github.com/tj/node-cookie-signature/graphs/contributors>),
  httpuv authors [ctb, cph] (Development of the http_date_string
    function)
Maintainer: Julio Collazos <amarullazo626@gmail.com>
Repository: CRAN
Date/Publication: 2026-06-12 10:10:09 UTC
Built: R 4.5.2; ; 2026-06-12 12:33:17 UTC; unix

stringifySetCookie <- function(name, val = NULL, ...) {
  opts <- list(...)

  if (is.list(name)) {
    val <- name$value
    name <- name$name
  }

  enc <- opts$encode %||% urlEncode

  val <- if (!nzchar(val)) {
    val
  } else {
    enc(val)
  }

  if (!grepl(cookieNameRegExp, name)) {
    stop("Argument name is invalid", call. = FALSE)
  }

  if (!grepl(cookieValueRegExp, val)) {
    stop("Argument val is invalid", call. = FALSE)
  }

  str <- paste0(name, "=", val)
  if (!length(opts)) {
    return(str)
  }

  if (!is.null(opts$maxAge)) {
    stopifnot(is.integer(opts$maxAge))
    str <- paste0(str, "; Max-Age=", opts$maxAge)
  }

  if (!is.null(opts$domain)) {
    stopifnot(grepl(domainValueRegExp, opts$domain))

    str <- paste0(str, "; Domain=", opts$domain)
  }

  if (!is.null(opts$path)) {
    stopifnot(grepl(pathValueRegExp, opts$path))

    str <- paste0(str, "; Path=", opts$path)
  }

  if (!is.null(opts$expires)) {
    stopifnot(
      # In R, date stuff are just double vectors with an additional class!
      is.finite(unclass(opts$expires)),
      inherits(opts$expires, c("Date", "POSIXct", "POSIXt"))
    )
    str <- paste0(str, "; Expires=", http_date_string(opts$expires))
  }

  if (isTRUE(opts$httpOnly)) {
    str <- paste0(str, "; HttpOnly")
  }

  if (isTRUE(opts$secure)) {
    str <- paste0(str, "; Secure")
  }

  if (isTRUE(opts$partitioned)) {
    str <- paste0(str, "; Partitioned")
  }

  if (!is.null(opts$priority)) {
    priority <- tolower(opts$priority)
    switch(
      priority,
      "low" = {
        str <- paste0(str, "; Priority=Low")
      },
      "medium" = {
        str <- paste0(str, "; Priority=Medium")
      },
      "high" = {
        str <- paste0(str, "; Priority=High")
      },
      stop("option priority is invalid: ", opts$priority, call. = FALSE)
    )
  }

  if (!is.null(opts$sameSite)) {
    sameSite <- opts$sameSite
    # If the value of EXPR is not a character string it is coerced to integer, from ?switch
    # so FALSE -> 0, no corresponding element, also we want to coerce  TRUE to
    # character.

    sameSite <- if (!isFALSE(sameSite)) tolower(sameSite) else sameSite

    switch(
      sameSite,
      "true" = ,
      "strict" = {
        str <- paste0(str, "; SameSite=Strict")
      },
      "lax" = {
        str <- paste0(str, "; SameSite=Lax")
      },
      "none" = {
        str <- paste0(str, "; SameSite=None")
      },

      stop("option sameSite is invalid: ", opts$sameSite, call. = FALSE)
    )
  }

  str
}

#' Serialise a Set-Cookie Header
#'
#' Serialises a cookie name-value pair into a `Set-Cookie` header string.
#'
#' @param name A string with the cookie name, or a list with `$name` and
#'   `$value` elements (in which case `val` is ignored).
#' @param val A string. The cookie value.
#' @param ... Additional cookie attributes:
#'   \describe{
#'     \item{`encode`}{A function to encode the cookie value. Defaults to
#'       [utils::URLencode()].}
#'     \item{`maxAge`}{An integer. Number of seconds until the cookie expires.}
#'     \item{`domain`}{A string. The cookie domain.}
#'     \item{`path`}{A string. The cookie path.}
#'     \item{`expires`}{A `Date`, `POSIXct`, or `POSIXt`. The expiry date.}
#'     \item{`httpOnly`}{Logical. Adds the `HttpOnly` attribute.}
#'     \item{`secure`}{Logical. Adds the `Secure` attribute.}
#'     \item{`partitioned`}{Logical. Adds the `Partitioned` attribute.}
#'     \item{`priority`}{A string: `"low"`, `"medium"`, or `"high"`.}
#'     \item{`sameSite`}{A string (`"strict"`, `"lax"`, `"none"`) or logical
#'       (`TRUE` maps to `"Strict"`).}
#'   }
#'
#' @return A `Set-Cookie` header string.
#'
#' @examples
#' serialise("session", "abc123")
#' serialise("id", "42", httpOnly = TRUE, secure = TRUE, sameSite = "lax")
#'
#' @export
serialise <- stringifySetCookie

describe("stringifySetCookie", {
  it("should serialize name and value", {
    expect_identical(
      stringifySetCookie("foo", "bar"),
      "foo=bar"
    )
  })

  it("should URL-encode value", {
    expect_identical(
      stringifySetCookie("foo", "bar +baz"),
      "foo=bar%20%2Bbaz"
    )
  })

  it("should serialize empty value", {
    expect_identical(
      stringifySetCookie("foo", ""),
      "foo="
    )
  })

  it("should serialize a list", {
    expect_identical(
      stringifySetCookie(
        list(name = "foo", value = "bar +baz")
      ),
      "foo=bar%20%2Bbaz"
    )
  })

  it("should serialize a list with options", {
    expect_identical(
      stringifySetCookie(
        list(name = "foo", value = "bar+baz"),
        encode = identity
      ),
      "foo=bar+baz"
    )
  })

  names <- c(
    "foo",
    "foo,bar",
    "foo!bar",
    "foo#bar",
    "foo$bar",
    "foo'bar",
    "foo*bar",
    "foo+bar",
    "foo-bar",
    "foo.bar",
    "foo^bar",
    "foo_bar",
    "foo`bar",
    "foo|bar",
    "foo~bar",
    "foo7bar",
    "foo/bar",
    "foo@bar",
    "foo[bar",
    "foo]bar",
    "foo:bar",
    "foo{bar",
    "foo}bar",
    'foo"bar',
    "foo<bar",
    "foo>bar",
    "foo?bar",
    "foo\\bar"
  )

  for (name in names) {
    it(sprintf("should serialize name: %s", name), {
      expect_identical(
        stringifySetCookie(name, "baz"),
        paste0(name, "=baz")
      )
    })
  }

  names <- c(
    "foo\n",
    "foo\u280a",
    "foo=bar",
    "foo;bar",
    "foo bar",
    "foo\tbar"
  )
  for (name in names) {
    it(sprintf("should throw for invalid name: %s", name), {
      expect_error(
        stringifySetCookie(name, "bar"),
        regexp = "Argument name is invalid"
      )
    })
  }

  describe('with "domain" option', {
    domains <- c(
      "examples.com",
      "sub.example.com",
      ".example.com",
      "localhost",
      ".localhost",
      "my-site.org"
    )

    for (domain in domains) {
      it(sprintf("should serialize domain: %s", domain), {
        expect_identical(
          stringifySetCookie("foo", "bar", domain = domain),
          sprintf('foo=bar; Domain=%s', domain)
        )
      })
    }

    domains <- c(
      "example.com\n",
      # "sub.example.com\u0000", Doesn't work in R...
      "my site.org",
      "domain..com",
      "example.com; Path=/",
      'example.com /* inject a comment */'
    )

    for (domain in domains) {
      it(sprintf("should throw for invalid domain: %s", domain), {
        expect_error(stringifySetCookie("foo", "bar", domain = domain))
      })
    }
  })

  describe('with "expires" option', {
    it("should throw on invalid date", {
      expect_error(stringifySetCookie("foo", "bar", expires = as.Date(NA)))
    })

    it("should set expires to given date", {
      expect_identical(
        stringifySetCookie(
          "foo",
          "bar",
          expires = as.POSIXct("2000-12-24 10:30:59", tz = "UTC")
        ),
        "foo=bar; Expires=Sun, 24 Dec 2000 10:30:59 GMT"
      )
    })
  })

  describe('with "httpOnly" option', {
    it("should include httpOnly flag when true", {
      expect_identical(
        stringifySetCookie("foo", "bar", httpOnly = TRUE),
        "foo=bar; HttpOnly"
      )
    })

    it("should not include httpOnly flag when false", {
      expect_identical(
        stringifySetCookie("foo", "bar", httpOnly = FALSE),
        "foo=bar"
      )
    })
  })

  describe('with "maxAge" option', {
    it("should throw when not a number", {
      expect_error(stringifySetCookie("foo", "bar", maxAge = "buzz"))
    })

    it("should throw when Infinity", {
      expect_error(stringifySetCookie("foo", "bar", maxAge = Inf))
    })

    it("should throw when max-age is not an integer", {
      expect_error(stringifySetCookie("foo", "bar", maxAge = 3.14))
    })

    it("should set max-age to value", {
      expect_identical(
        stringifySetCookie("foo", "bar", maxAge = 1000L),
        "foo=bar; Max-Age=1000"
      )

      expect_identical(
        stringifySetCookie("foo", "bar", maxAge = 0L),
        "foo=bar; Max-Age=0"
      )
    })

    it("should not set when undefined", {
      expect_identical(
        stringifySetCookie("foo", "bar", maxAge = NULL),
        "foo=bar"
      )
    })
  })

  describe('with "partitioned" option', {
    it("should include partitioned flag when true", {
      expect_identical(
        stringifySetCookie("foo", "bar", partitioned = TRUE),
        "foo=bar; Partitioned"
      )
    })

    it("should not include partitioned flag when false", {
      expect_identical(
        stringifySetCookie("foo", "bar", partitioned = FALSE),
        "foo=bar"
      )
    })

    it("should not include partitioned flag when not defined", {
      expect_identical(
        stringifySetCookie("foo", "bar"),
        "foo=bar"
      )
    })
  })

  describe('with "path" option', {
    it("should serialize path", {
      validPaths <- c(
        "/",
        "/login",
        "/foo.bar/baz",
        "/foo-bar",
        "/foo=bar?baz",
        '/foo"bar"',
        "/../foo/bar",
        "../foo/",
        "./"
      )

      for (path in validPaths) {
        expect_identical(
          stringifySetCookie("foo", "bar", path = path),
          paste0("foo=bar; Path=", path)
        )
      }
    })

    it("should throw for invalid value", {
      invalidPaths <- c(
        "/\n",
        # "/foo\u0000",
        "/path/with\rnewline",
        "/; Path=/sensitive-data",
        '/login"><script>alert(1)</script>'
      )

      for (path in invalidPaths) {
        expect_error(stringifySetCookie("foo", "bar", path = path))
      }
    })
  })

  describe('with "priority" option', {
    it("should throw on invalid priority", {
      expect_error(
        stringifySetCookie("foo", "bar", priority = "foo"),
        regexp = "option priority is invalid"
      )
    })

    it("should throw on non-string", {
      expect_error(
        stringifySetCookie("foo", "bar", priority = 42),
        regexp = "option priority is invalid"
      )
    })

    it("should set priority low", {
      expect_identical(
        stringifySetCookie("foo", "bar", priority = "low"),
        "foo=bar; Priority=Low"
      )
    })

    it("should set priority medium", {
      expect_identical(
        stringifySetCookie("foo", "bar", priority = "medium"),
        "foo=bar; Priority=Medium"
      )
    })

    it("should set priority high", {
      expect_identical(
        stringifySetCookie("foo", "bar", priority = "high"),
        "foo=bar; Priority=High"
      )
    })

    it("should set priority case insensitive", {
      expect_identical(
        stringifySetCookie("foo", "bar", priority = "High"),
        "foo=bar; Priority=High"
      )
    })
  })

  describe('with "sameSite" option', {
    it("should throw on invalid sameSite", {
      expect_error(stringifySetCookie("foo", "bar", sameSite = "foo"))
    })

    it("should set sameSite strict", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = "strict"),
        "foo=bar; SameSite=Strict"
      )
    })

    it("should set sameSite lax", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = "lax"),
        "foo=bar; SameSite=Lax"
      )
    })

    it("should set sameSite none", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = "none"),
        "foo=bar; SameSite=None"
      )
    })

    it("should set sameSite strict when true", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = TRUE),
        "foo=bar; SameSite=Strict"
      )
    })

    it("should not set sameSite strict when false", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = FALSE),
        "foo=bar"
      )
    })

    it("should set sameSite case insensitive", {
      expect_identical(
        stringifySetCookie("foo", "bar", sameSite = "Lax"),
        "foo=bar; SameSite=Lax"
      )
    })
  })

  describe('with "secure" option', {
    it("should include secure flag when true", {
      expect_identical(
        stringifySetCookie("foo", "bar", secure = TRUE),
        "foo=bar; Secure"
      )
    })

    it("should not include secure flag when false", {
      expect_identical(
        stringifySetCookie("foo", "bar", secure = FALSE),
        "foo=bar"
      )
    })
  })
})

'%||%' <- function(x, y) {
  if (is.null(x)) y else x
}

urlEncode <- function(URL) {
  utils::URLencode(URL, reserved = TRUE)
}

# Shamelessly copied from:
# https://github.com/rstudio/httpuv/blob/main/tests/testthat/helper-app.R#L131

http_date_string <- function(time) {
  weekday_names <- c("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat")
  weekday_num <- as.integer(strftime(time, format = "%w", tz = "GMT"))
  weekday_name <- weekday_names[weekday_num + 1]

  month_names <- c(
    "Jan",
    "Feb",
    "Mar",
    "Apr",
    "May",
    "Jun",
    "Jul",
    "Aug",
    "Sep",
    "Oct",
    "Nov",
    "Dec"
  )
  month_num <- as.integer(strftime(time, format = "%m", tz = "GMT"))
  month_name <- month_names[month_num]

  strftime(
    time,
    paste0(weekday_name, ", %d ", month_name, " %Y %H:%M:%S GMT"),
    tz = "GMT"
  )
}


# https://github.com/jshttp/cookie/blob/e8db32e04f7aa5affff00724c8a28dd0d17fc397/src/index.ts#L2

cookieNameRegExp <- "^[\u0021-\u003A\u003C\u003E-\u007E]+$"

# https://github.com/jshttp/cookie/blob/e8db32e04f7aa5affff00724c8a28dd0d17fc397/src/index.ts#L18

cookieValueRegExp <- "^[\u0021-\u003A\u003C-\u007E]*$"

# https://github.com/jshttp/cookie/blob/e8db32e04f7aa5affff00724c8a28dd0d17fc397/src/index.ts#L32

domainValueRegExp <- "^(?i)([.]?[a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?)([.][a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?)*$"

# https://github.com/jshttp/cookie/blob/e8db32e04f7aa5affff00724c8a28dd0d17fc397/src/index.ts#L58

pathValueRegExp <- "^[\u0020-\u003A\u003D-\u007E]*$"

#' Sign a Cookie Value
#'
#' Sign the given `val` with `secret`.
#'
#' @param val A string. The cookie value to sign.
#' @param secret The secret key used to generate the signature.
#'
#' @return A string of the form `"<val>.<signature>"`.
#'
#' @examples
#' sign("hello", "tobiiscool")
#'
#' @export
sign <- function(val, secret) {
  stopifnot("Cookie value must be a string" = is.character(val))

  rand <- secretbase::sha256(val, key = secret, convert = FALSE)
  rand <- secretbase::base64enc(rand)
  rand <- sub("\\=+$", "", rand)
  paste0(val, ".", rand)
}

#' Unsign a Cookie Value
#'
#' Verifies the signature of a signed cookie value and returns the original
#' value if valid, or `FALSE` if the signature does not match.
#'
#' @param input A string. A signed cookie value produced by [sign()].
#' @param secret The secret key to verify against.
#'
#' @return The original unsigned value if verification succeeds, `FALSE`
#'   otherwise.
#'
#' @examples
#' input <- sign("hello", "tobiiscool")
#' unsign(input, "tobiiscool")
#' unsign(input, "luna")
#'
#' @export
unsign <- function(input, secret) {
  stopifnot("Signed cookie must be a string" = is.character(input))
  tentativeValue <- strsplit(input, split = ".", fixed = TRUE)[[1]][1]
  expectedInput <- sign(tentativeValue, secret)
  expectedBuffer <- charToRaw(expectedInput)
  inputBuffer <- charToRaw(input)

  return(
    if (
      length(expectedBuffer) == length(inputBuffer) &&
        identical(expectedBuffer, inputBuffer)
    ) {
      tentativeValue
    } else {
      FALSE
    }
  )
}

describe("sign", {
  it("should sign the cookie", {
    val <- sign("hello", "tobiiscool")
    expect_identical(val, "hello.DGDUkGlIkCzPz+C0B064FNgHdEjox7ch8tOBGslZ5QI")

    val <- sign("hello", "luna")
    expect_false(identical(
      val,
      "hello.DGDUkGlIkCzPz+C0B064FNgHdEjox7ch8tOBGslZ5QI"
    ))
  })
  it("should accept appropiately non-string secrets", {
    key <- as.raw(c(0xA0, 0xAB, 0xBC, 0x0C))
    val <- sign("hello", key)
    expect_identical(val, 'hello.hIvljrKw5oOZtHHSq5u+MlL27cgnPKX77y7F+x5r1to')
  })
})

describe("unsign", {
  it("should unsign the cookie", {
    val <- sign("hello", "tobiiscool")

    expect_identical(unsign(val, "tobiiscool"), "hello")
    expect_false(unsign(val, "luna"))
  })

  it("should reject malformed cookies", {
    pwd <- "actual sekrit password"

    expect_false(unsign("fake unsigned data", pwd))

    val <- sign("real data", pwd)
    expect_false(unsign(paste0("garbage", val), pwd))
    expect_false(unsign(paste0("garbage.", val), pwd))
    expect_false(unsign(paste0(val, ".garbage"), pwd))
    expect_false(unsign(paste0(val, "garbage"), pwd))
  })

  it("should accept non-string secrets", {
    key <- as.raw(c(0xA0, 0xAB, 0xBC, 0x0C))
    val <- unsign('hello.hIvljrKw5oOZtHHSq5u+MlL27cgnPKX77y7F+x5r1to', key)
    expect_identical(val, "hello")
  })
})

#' Cookie Parser Middleware
#'
#' Creates a middleware function that parses the `Cookie` HTTP header and
#' populates `req$cookies`. When a `secret` is provided, signed cookies are
#' verified and exposed on `req$signedCookies`.
#'
#' @param secret A character vector or list of strings used to sign
#'   and verify cookies. Optional.
#' @param options A function used to decode cookie values. Defaults to
#'   [utils::URLdecode()].
#'
#' @return A middleware function that sets `req$cookies`,
#'   `req$signedCookies`, and `req$secret`, then calls `forward()`.
#'
#' @export
cookieParser <- function(secret = NULL, options = NULL) {
  secrets <- as.list(secret %||% list())

  function(req, res) {
    if (!is.null(req$cookies)) {
      return(forward())
    }

    cookies <- req$HTTP_COOKIE

    req$secret <- secret[[1]]
    req$cookies <- list()
    req$signedCookies <- list()

    if (is.null(cookies)) {
      return(forward())
    }

    req$cookies <- parseCookie(cookies, options)

    if (length(secrets)) {
      req$signedCookies <- signedCookies(req$cookies, secrets)
      req$cookies[names(req$signedCookies)] <- NULL
    }

    forward()
  }
}


signedCookie <- function(str, secrets) {
  if (!is.character(str)) {
    return(NULL)
  }

  if (substr(str, 1, 2) != "s:") {
    return(str)
  }

  for (secret in secrets) {
    val <- unsign(substr(str, 3, nchar(str)), secret)

    if (!isFALSE(val)) {
      return(val)
    }
  }

  FALSE
}


signedCookies <- function(obj, secret) {
  cookies <- names(obj)
  ret <- list()

  for (key in cookies) {
    val <- obj[[key]]
    dec <- signedCookie(val, secret)

    if (!identical(val, dec)) {
      ret[[key]] <- dec
    }
  }

  ret
}


# To keep R CMD check happy
utils::globalVariables(
  "forward"
)

describe("cookieParser()", {
  on.exit(
    {
      httpuv::stopAllServers()
    },
    add = TRUE
  )

  describe("when no cookies are sent", {
    it("should default req$cookies to {}", {
      r <- fetch(createServer("keyboard cat"), "/")

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          "{}"
        )
      )
    })

    it("should default req$signedCookies to {}", {
      r <- fetch(createServer("keyboard cat"), "/signed")

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          "{}"
        )
      )
    })
  })

  describe("when cookies are sent", {
    it("should populate req$cookies", {
      r <- fetch(
        createServer("keyboard cat"),
        path = "/",
        headers = list(
          "Cookie" = "foo=bar; bar=baz"
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          '{"foo":"bar","bar":"baz"}'
        )
      )
    })
  })

  describe("when a secret is given", {
    val <- sign("foobarbaz", "keyboard cat")

    it("should populate req$signedCookies", {
      r <- fetch(
        createServer("keyboard cat"),
        path = "/signed",
        headers = list(
          "Cookie" = paste0("foo=s:", val)
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          '{"foo":"foobarbaz"}'
        )
      )
    })

    it("should remove the signed value from req$cookies", {
      r <- fetch(
        createServer("keyboard cat"),
        path = "/",
        headers = list(
          "Cookie" = paste0("foo=s:", val)
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          "{}"
        )
      )
    })

    it("should omit invalid signature", {
      server <- createServer("keyboard cat")

      r <- fetch(
        server,
        path = "/signed",
        headers = list(
          "Cookie" = paste0("foo=", val, "3")
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          "{}"
        )
      )

      r <- fetch(
        server,
        path = "/",
        headers = list(
          "Cookie" = paste0("foo=", val, "3")
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          '{"foo":"foobarbaz.CP7AWaXDfAKIRfH49dQzKJx7sKzzSoPq7/AcBBRVwlI3"}'
        )
      )
    })
  })

  describe("when multiple secrets are given", {
    it("should populate req$signedCookies", {
      r <- fetch(
        createServer(list("keyboard cat", "nyan cat")),
        "/signed",
        headers = list(
          Cookie = 'buzz=s:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE; fizz=s:foobar.JTCAgiMWsnuZpN3mrYnEUjXlGxmDi4POCBnWbRxse88'
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          '{"buzz":"foobar","fizz":"foobar"}'
        )
      )
    })
  })

  describe("when no secret is given", {
    server <- createServer()

    it("should populate req$cookies", {
      r <- fetch(
        server,
        "/",
        headers = list(
          Cookie = 'foo=bar; bar=baz'
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          '{"foo":"bar","bar":"baz"}'
        )
      )
    })

    it("should not populate req$signedCookies", {
      val <- sign("foobarbaz", "keyboard cat")

      r <- fetch(
        server,
        "/signed",
        headers = list(
          Cookie = paste0("foo=s:", val)
        )
      )

      expect_identical(
        list(
          r$status,
          r$body
        ),
        list(
          200L,
          "{}"
        )
      )
    })
  })

  describe("signedCookie", {
    it("should return NULL for non-string arguments", {
      expect_null(signedCookie(NULL, "keyboard cat"))
      expect_null(signedCookie(42, "keyboard cat"))
      expect_null(signedCookie(list(), "keyboard cat"))
      expect_null(signedCookie(function(x) {}, "keyboard cat"))
    })

    it("should pass through non-signed strings", {
      expect_identical(signedCookie("", "keyboard cat"), "")
      expect_identical(signedCookie("foo", "keyboard cat"), "foo")
    })

    it("should return FALSE for tampered signed strings", {
      expect_false(
        signedCookie(
          's:foobaz.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
          "keyboard cat"
        )
      )
    })

    it("should return unsigned value for signed strings", {
      expect_identical(
        signedCookie(
          's:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
          "keyboard cat"
        ),
        "foobar"
      )
    })

    describe("when secret is a list", {
      it("should return FALSE for tampered signed string", {
        expect_false(
          signedCookie(
            's:foobaz.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
            list(
              "keyboard cat",
              "nyan cat"
            )
          )
        )
      })

      it("should return unsigned value for first secret", {
        expect_identical(
          signedCookie(
            's:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
            list(
              "keyboard cat",
              "nyan cat"
            )
          ),
          "foobar"
        )
      })

      it("should return unsigned value for second secret", {
        expect_identical(
          signedCookie(
            's:foobar.JTCAgiMWsnuZpN3mrYnEUjXlGxmDi4POCBnWbRxse88',
            list(
              "keyboard cat",
              "nyan cat"
            )
          ),
          "foobar"
        )
      })
    })
  })

  describe("signedCookies(obj, secret)", {
    it("should ignore non-signed strings", {
      expect_identical(signedCookies(list(), "keyboard cat"), list())
      expect_identical(signedCookies(list(foo = "bar")), list())
    })

    it("should include tampered strings as false", {
      expect_identical(
        signedCookies(
          list(
            foo = 's:foobaz.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE'
          ),
          "keyboard cat"
        ),
        list(
          foo = FALSE
        )
      )
    })

    it("should include unsigned strings", {
      expect_identical(
        signedCookies(
          list(
            foo = 's:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE'
          ),
          "keyboard cat"
        ),
        list(
          foo = "foobar"
        )
      )
    })

    describe("when secret is a list", {
      it("should include unsigned strings for matching secrets", {
        obj <- list(
          buzz = 's:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
          fizz = 's:foobar.JTCAgiMWsnuZpN3mrYnEUjXlGxmDi4POCBnWbRxse88'
        )

        expect_identical(
          signedCookies(obj, list("keyboard cat")),
          list(
            buzz = "foobar",
            fizz = FALSE
          )
        )
      })

      it("should include unsigned strings for all secrets", {
        obj <- list(
          buzz = 's:foobar.N5r0C3M8W+IPpzyAJaIddMWbTGfDSO+bfKlZErJ+MeE',
          fizz = 's:foobar.JTCAgiMWsnuZpN3mrYnEUjXlGxmDi4POCBnWbRxse88'
        )

        expect_identical(
          signedCookies(obj, list("keyboard cat", "nyan cat")),
          list(
            buzz = "foobar",
            fizz = "foobar"
          )
        )
      })
    })
  })
})

Response <- R6::R6Class(
  "Response",
  public = list(
    status = NULL,
    headers = list(),
    body = NULL,
    send = function(body = NULL) {
      list(
        status = self$status,
        headers = self$headers,
        body = body
      )
    },
    json = function(body = NULL) {
      if (!length(body)) {
        body <- setNames(list(), character(0))
      }
      self$send(yyjsonr::write_json_str(
        body,
        opts = yyjsonr::opts_write_json(auto_unbox = TRUE)
      ))
    }
  )
)

createServer <- function(secret = NULL) {
  router <- routing::Router$new()
  router$use(cookieParser(secret))
  router$get("/", \(req, res) {
    res$status <- 200L
    res$json(req$cookies)
  })
  router$get("/signed", \(req, res) {
    res$status <- 200L
    res$json(req$signedCookies)
  })

  httpuv::startServer(
    "127.0.0.1",
    httpuv::randomPort(),
    list(
      call = function(req) {
        res <- Response$new()
        router$handle(req, res, routing::finalHandler(req, res))
      }
    )
  )
}

fetch <- function(server, path, method = "GET", headers = NULL) {
  url <- paste0("http://127.0.0.1:", server$getPort(), path)
  handle <- curl::new_handle(customrequest = toupper(method))
  if (!is.null(headers)) {
    curl::handle_setheaders(handle, .list = headers)
  }
  pool <- curl::new_pool()
  result <- NULL
  error <- NULL

  curl::curl_fetch_multi(
    url,
    done = function(r) result <<- r,
    fail = function(e) error <<- e,
    handle = handle,
    pool = pool
  )

  while (is.null(result) && is.null(error)) {
    later::run_now(0)
    curl::multi_run(timeout = 0.01, pool = pool)
  }

  if (!is.null(error)) {
    stop(error)
  }

  list(
    status = result$status_code,
    body = rawToChar(result$content),
    headers = curl::parse_headers_list(result$headers)
  )
}

parseCookie <- function(str, options = NULL) {
  if (is.null(options)) {
    options <- decode
  }

  obj <- list()

  len <- nchar(str)

  # RFC 6265 sec 4.1.1, RFC 2616 2.2 defines a cookie name consists of one char minimum, plus '='.
  if (len < 2) {
    return(obj)
  }

  dec <- options
  index <- 1
  while (index < len) {
    eqIdx <- eqIndex(str, index, len)
    if (eqIdx == -1) {
      break
    }

    endIdx <- endIndex(str, index, len)

    if (eqIdx > endIdx) {
      # backtrack on prior semicolon
      m <- gregexpr(";", substring(str, 1, eqIdx))[[1]]
      index <- m[length(m)] + 1
      next
    }

    key <- valueSlice(str, index, eqIdx)

    # only assign once
    if (is.null(obj[[key]])) {
      obj[[key]] <- dec(valueSlice(str, eqIdx + 1, endIdx))
    }
    index <- endIdx + 1
  }

  obj
}


indexOf <- function(str, pattern, min = 1) {
  stopifnot(length(str) == 1)
  m <- gregexpr(pattern, str)[[1]]
  m <- m[m >= min]
  if (!length(m)) -1L else m[1]
}

endIndex <- function(str, min, len) {
  index <- indexOf(str, ";", min)
  # R also represent -1 as no pattern match!
  if (index == -1L) len + 1L else index
}

eqIndex <- function(str, min, max) {
  index <- indexOf(str, "=", min)
  if (index <= max) index else -1L
}

valueSlice <- function(str, min, max) {
  if (min == max) {
    return("")
  }
  start <- min
  end <- max

  while (start < end) {
    # ascii code
    code <- utf8ToInt(substring(str, start, start))
    if (code != 32 && code != 9) {
      break
    }
    start <- start + 1
  }

  while (end > start) {
    code <- utf8ToInt(substring(str, end - 1L, end - 1L))
    if (code != 32 && code != 9) {
      break
    }
    end <- end - 1L
  }

  substring(str, start, end - 1L)
}

decode <- function(str) {
  if (regexpr("%", str) == -1) {
    return(str)
  }

  # As far as I know this function doesn't return an error
  utils::URLdecode(str)
}

describe("parseCookie", {
  it("should parse cookie string to object", {
    expect_identical(
      parseCookie("foo=bar"),
      list(foo = "bar")
    )
    expect_identical(
      parseCookie("foo=123"),
      list(foo = "123")
    )
  })

  it("should ignore OWS", {
    expect_identical(
      parseCookie("FOO    = bar;   baz  =   raz"),
      list(
        FOO = "bar",
        baz = "raz"
      )
    )
  })

  it("should return empty object", {
    expect_identical(
      parseCookie(""),
      list()
    )

    expect_identical(
      parseCookie(" \t "),
      list()
    )
  })

  it("should parse cookie with empty value", {
    expect_identical(
      parseCookie("foo=; bar="),
      list(
        foo = "",
        bar = ""
      )
    )
  })

  it("should parse cookie with minimum length", {
    expect_identical(
      parseCookie("f="),
      list(
        f = ""
      )
    )
    expect_identical(
      parseCookie("f=;b="),
      list(
        f = "",
        b = ""
      )
    )
  })

  it("should URL-decode value", {
    expect_identical(
      parseCookie('foo="bar=123456789&name=Magic+Mouse"'),
      list(
        foo = '"bar=123456789&name=Magic+Mouse"'
      )
    )

    expect_identical(
      parseCookie("email=%20%22%2c%3b%2f"),
      list(
        email = ' ",;/'
      )
    )
  })

  it("should trim whitespace around key and value", {
    expect_identical(
      parseCookie('  foo  =  "bar"  '),
      list(
        foo = '"bar"'
      )
    )

    expect_identical(
      parseCookie("  foo  =  bar  ;  fizz  =  buzz  "),
      list(
        foo = "bar",
        fizz = "buzz"
      )
    )

    expect_identical(
      parseCookie(' foo = " a b c " '),
      list(foo = '" a b c "')
    )

    # Not allowed in R
    # expect_identical(
    #   parseCookie(" = bar "), # This one should result in an eror I think
    # )

    expect_identical(
      parseCookie(" foo = "),
      list(foo = "")
    )

    # expect_identical(
    #   parseCookie(" = ") # Should return an error...
    # )

    expect_identical(
      parseCookie("\tfoo\t=\tbar\t"),
      list(
        foo = "bar"
      )
    )
  })

  # Doesn't work as utils::URLdecode doesn't return errors...

  # it("should return original value on escape error", {
  #   expect_identical(
  #     parseCookie("foo=%1;bar=bar"),
  #     list(
  #       foo = "%1",
  #       bar = "bar"
  #     )
  #   )
  # })

  it("should ignore cookie without value", {
    expect_identical(
      parseCookie("foo=bar; fizz  ; buzz"),
      list(
        foo = "bar"
      )
    )

    expect_identical(
      parseCookie("  fizz;foo= bar"),
      list(
        foo = "bar"
      )
    )
  })

  it("should ignore duplicate cookies", {
    expect_identical(
      parseCookie("foo=false;bar=bar;foo=true"),
      list(
        foo = "false",
        bar = "bar"
      )
    )

    expect_identical(
      parseCookie("foo=;bar=bar;foo=boo"),
      list(
        foo = "",
        bar = "bar"
      )
    )
  })

  it("should parse native properties", {
    expect_identical(
      parseCookie("toString=foo;valueOf=bar"),
      list(
        toString = "foo",
        valueOf = "bar"
      )
    )
  })
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signature.R
\name{sign}
\alias{sign}
\title{Sign a Cookie Value}
\usage{
sign(val, secret)
}
\arguments{
\item{val}{A string. The cookie value to sign.}

\item{secret}{The secret key used to generate the signature.}
}
\value{
A string of the form \code{"<val>.<signature>"}.
}
\description{
Sign the given \code{val} with \code{secret}.
}
\examples{
sign("hello", "tobiiscool")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signature.R
\name{unsign}
\alias{unsign}
\title{Unsign a Cookie Value}
\usage{
unsign(input, secret)
}
\arguments{
\item{input}{A string. A signed cookie value produced by \code{\link[=sign]{sign()}}.}

\item{secret}{The secret key to verify against.}
}
\value{
The original unsigned value if verification succeeds, \code{FALSE}
otherwise.
}
\description{
Verifies the signature of a signed cookie value and returns the original
value if valid, or \code{FALSE} if the signature does not match.
}
\examples{
input <- sign("hello", "tobiiscool")
unsign(input, "tobiiscool")
unsign(input, "luna")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/middleware.R
\name{cookieParser}
\alias{cookieParser}
\title{Cookie Parser Middleware}
\usage{
cookieParser(secret = NULL, options = NULL)
}
\arguments{
\item{secret}{A character vector or list of strings used to sign
and verify cookies. Optional.}

\item{options}{A function used to decode cookie values. Defaults to
\code{\link[utils:URLencode]{utils::URLdecode()}}.}
}
\value{
A middleware function that sets \code{req$cookies},
\code{req$signedCookies}, and \code{req$secret}, then calls \code{forward()}.
}
\description{
Creates a middleware function that parses the \code{Cookie} HTTP header and
populates \code{req$cookies}. When a \code{secret} is provided, signed cookies are
verified and exposed on \code{req$signedCookies}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stringifySetCookie.R
\name{serialise}
\alias{serialise}
\title{Serialise a Set-Cookie Header}
\usage{
serialise(name, val = NULL, ...)
}
\arguments{
\item{name}{A string with the cookie name, or a list with \verb{$name} and
\verb{$value} elements (in which case \code{val} is ignored).}

\item{val}{A string. The cookie value.}

\item{...}{Additional cookie attributes:
\describe{
\item{\code{encode}}{A function to encode the cookie value. Defaults to
\code{\link[utils:URLencode]{utils::URLencode()}}.}
\item{\code{maxAge}}{An integer. Number of seconds until the cookie expires.}
\item{\code{domain}}{A string. The cookie domain.}
\item{\code{path}}{A string. The cookie path.}
\item{\code{expires}}{A \code{Date}, \code{POSIXct}, or \code{POSIXt}. The expiry date.}
\item{\code{httpOnly}}{Logical. Adds the \code{HttpOnly} attribute.}
\item{\code{secure}}{Logical. Adds the \code{Secure} attribute.}
\item{\code{partitioned}}{Logical. Adds the \code{Partitioned} attribute.}
\item{\code{priority}}{A string: \code{"low"}, \code{"medium"}, or \code{"high"}.}
\item{\code{sameSite}}{A string (\code{"strict"}, \code{"lax"}, \code{"none"}) or logical
(\code{TRUE} maps to \code{"Strict"}).}
}}
}
\value{
A \code{Set-Cookie} header string.
}
\description{
Serialises a cookie name-value pair into a \code{Set-Cookie} header string.
}
\examples{
serialise("session", "abc123")
serialise("id", "42", httpOnly = TRUE, secure = TRUE, sameSite = "lax")

}
